Subject: Re: [PATCH/RFC 0/4] config: read both home and xdg files for --global

From: Johannes Schindelin <[email-masked]>
Date: Mon, 17 Nov 2025 14:29:33 +0100 (CET)

Hi,

On Fri, 10 Oct 2025, Delilah Ashley Wu via GitGitGadget wrote:

> As reported in [1]: `$HOME/.gitconfig` and `$XDG_CONFIG_HOME/git/config` are
> both valid global config locations, but `git config list --global` only
> includes the former in its output.
> 
> Suppose we have this config in `$HOME/.gitconfig`:
> 
> [home]
>     config = true
> 
> 
> And this config in `$XDG_CONFIG_HOME/git/config`:
> 
> [xdg]
>     config = true
> 
> 
> Then, to reproduce the issue that `--global` only shows the home config:
> 
> $ git config list --global --show-scope --show-origin
> global  file:/Users/delilah/.gitconfig    home.config=true
> 
> 
> Git correctly applies the XDG config in its effective configuration, but it
> doesn't show up when `--global` is specified. We can confirm this by
> checking the output without the `--global` flag:
> 
> $ git config list --show-scope --show-origin
> global  file:/Users/delilah/.config/git/config    xdg.config=true
> global  file:/Users/delilah/.gitconfig            home.config=true
> 
> 
> The expected behaviour is both configs should be shown when `--global` is
> specified, so we'd expect its output to look the same as above. This was
> confirmed in [2], which quoted the `git config` documentation:
> 
> > OPTIONS
> >     --global::
> >         For writing options: write to global `~/.gitconfig` file
> >         rather than the repository `.git/config`, write to
> >         `$XDG_CONFIG_HOME/git/config` file if this file exists and the
> >         `~/.gitconfig` file doesn't.
> >
> >         For reading options: read only from global `~/.gitconfig` and from
> >         `$XDG_CONFIG_HOME/git/config` rather than from all available files.
> 
> 
> The first patch fixes forward slash normalisation on Windows paths. The
> second patch introduces tests and regression checks. The third and fourth
> patches implement the fix to include both config files when `--global` is
> specified. Johannes has kindly pre-reviewed this patch series via GitHub on
> GitGitGadget #1938 [3]. You'll notice some force-pushes after the review,
> but I only changed commit messages.
> 
> [1]:
> https://lore.kernel.org/git/[email-masked]/
> [2]: https://lore.kernel.org/git/[email-masked]/
> [3]: https://github.com/gitgitgadget/git/pull/1938/
> 
> Thank you all for your time!

For the record, my "Reviewed-by:" still stands, if lack of reviews should
be the reason why this patch series has not even entered the `seen`
branch.

Ciao,
Johannes